Index: lemon/circulation.h
===================================================================
--- lemon/circulation.h	(revision 581)
+++ lemon/circulation.h	(revision 492)
@@ -216,7 +216,7 @@
     ///@{
 
-    template <typename T>
+    template <typename _FlowMap>
     struct SetFlowMapTraits : public Traits {
-      typedef T FlowMap;
+      typedef _FlowMap FlowMap;
       static FlowMap *createFlowMap(const Digraph&) {
         LEMON_ASSERT(false, "FlowMap is not initialized");
@@ -230,15 +230,15 @@
     /// \ref named-templ-param "Named parameter" for setting FlowMap
     /// type.
-    template <typename T>
+    template <typename _FlowMap>
     struct SetFlowMap
       : public Circulation<Digraph, LCapMap, UCapMap, DeltaMap,
-                           SetFlowMapTraits<T> > {
+                           SetFlowMapTraits<_FlowMap> > {
       typedef Circulation<Digraph, LCapMap, UCapMap, DeltaMap,
-                          SetFlowMapTraits<T> > Create;
+                          SetFlowMapTraits<_FlowMap> > Create;
     };
 
-    template <typename T>
+    template <typename _Elevator>
     struct SetElevatorTraits : public Traits {
-      typedef T Elevator;
+      typedef _Elevator Elevator;
       static Elevator *createElevator(const Digraph&, int) {
         LEMON_ASSERT(false, "Elevator is not initialized");
@@ -256,15 +256,15 @@
     /// \ref run() or \ref init().
     /// \sa SetStandardElevator
-    template <typename T>
+    template <typename _Elevator>
     struct SetElevator
       : public Circulation<Digraph, LCapMap, UCapMap, DeltaMap,
-                           SetElevatorTraits<T> > {
+                           SetElevatorTraits<_Elevator> > {
       typedef Circulation<Digraph, LCapMap, UCapMap, DeltaMap,
-                          SetElevatorTraits<T> > Create;
+                          SetElevatorTraits<_Elevator> > Create;
     };
 
-    template <typename T>
+    template <typename _Elevator>
     struct SetStandardElevatorTraits : public Traits {
-      typedef T Elevator;
+      typedef _Elevator Elevator;
       static Elevator *createElevator(const Digraph& digraph, int max_level) {
         return new Elevator(digraph, max_level);
@@ -284,10 +284,10 @@
     /// before calling \ref run() or \ref init().
     /// \sa SetElevator
-    template <typename T>
+    template <typename _Elevator>
     struct SetStandardElevator
       : public Circulation<Digraph, LCapMap, UCapMap, DeltaMap,
-                       SetStandardElevatorTraits<T> > {
+                       SetStandardElevatorTraits<_Elevator> > {
       typedef Circulation<Digraph, LCapMap, UCapMap, DeltaMap,
-                      SetStandardElevatorTraits<T> > Create;
+                      SetStandardElevatorTraits<_Elevator> > Create;
     };
 
@@ -454,11 +454,11 @@
 
       for(NodeIt n(_g);n!=INVALID;++n) {
-        (*_excess)[n] = (*_delta)[n];
+        _excess->set(n, (*_delta)[n]);
       }
 
       for (ArcIt e(_g);e!=INVALID;++e) {
         _flow->set(e, (*_lo)[e]);
-        (*_excess)[_g.target(e)] += (*_flow)[e];
-        (*_excess)[_g.source(e)] -= (*_flow)[e];
+        _excess->set(_g.target(e), (*_excess)[_g.target(e)] + (*_flow)[e]);
+        _excess->set(_g.source(e), (*_excess)[_g.source(e)] - (*_flow)[e]);
       }
 
@@ -483,5 +483,5 @@
 
       for(NodeIt n(_g);n!=INVALID;++n) {
-        (*_excess)[n] = (*_delta)[n];
+        _excess->set(n, (*_delta)[n]);
       }
 
@@ -489,15 +489,15 @@
         if (!_tol.positive((*_excess)[_g.target(e)] + (*_up)[e])) {
           _flow->set(e, (*_up)[e]);
-          (*_excess)[_g.target(e)] += (*_up)[e];
-          (*_excess)[_g.source(e)] -= (*_up)[e];
+          _excess->set(_g.target(e), (*_excess)[_g.target(e)] + (*_up)[e]);
+          _excess->set(_g.source(e), (*_excess)[_g.source(e)] - (*_up)[e]);
         } else if (_tol.positive((*_excess)[_g.target(e)] + (*_lo)[e])) {
           _flow->set(e, (*_lo)[e]);
-          (*_excess)[_g.target(e)] += (*_lo)[e];
-          (*_excess)[_g.source(e)] -= (*_lo)[e];
+          _excess->set(_g.target(e), (*_excess)[_g.target(e)] + (*_lo)[e]);
+          _excess->set(_g.source(e), (*_excess)[_g.source(e)] - (*_lo)[e]);
         } else {
           Value fc = -(*_excess)[_g.target(e)];
           _flow->set(e, fc);
-          (*_excess)[_g.target(e)] = 0;
-          (*_excess)[_g.source(e)] -= fc;
+          _excess->set(_g.target(e), 0);
+          _excess->set(_g.source(e), (*_excess)[_g.source(e)] - fc);
         }
       }
@@ -538,8 +538,8 @@
             if(!_tol.less(fc, exc)) {
               _flow->set(e, (*_flow)[e] + exc);
-              (*_excess)[v] += exc;
+              _excess->set(v, (*_excess)[v] + exc);
               if(!_level->active(v) && _tol.positive((*_excess)[v]))
                 _level->activate(v);
-              (*_excess)[act] = 0;
+              _excess->set(act,0);
               _level->deactivate(act);
               goto next_l;
@@ -547,5 +547,5 @@
             else {
               _flow->set(e, (*_up)[e]);
-              (*_excess)[v] += fc;
+              _excess->set(v, (*_excess)[v] + fc);
               if(!_level->active(v) && _tol.positive((*_excess)[v]))
                 _level->activate(v);
@@ -562,8 +562,8 @@
             if(!_tol.less(fc, exc)) {
               _flow->set(e, (*_flow)[e] - exc);
-              (*_excess)[v] += exc;
+              _excess->set(v, (*_excess)[v] + exc);
               if(!_level->active(v) && _tol.positive((*_excess)[v]))
                 _level->activate(v);
-              (*_excess)[act] = 0;
+              _excess->set(act,0);
               _level->deactivate(act);
               goto next_l;
@@ -571,5 +571,5 @@
             else {
               _flow->set(e, (*_lo)[e]);
-              (*_excess)[v] += fc;
+              _excess->set(v, (*_excess)[v] + fc);
               if(!_level->active(v) && _tol.positive((*_excess)[v]))
                 _level->activate(v);
@@ -580,5 +580,5 @@
         }
 
-        (*_excess)[act] = exc;
+        _excess->set(act, exc);
         if(!_tol.positive(exc)) _level->deactivate(act);
         else if(mlevel==_node_num) {
@@ -683,5 +683,5 @@
     ///
     /// \note This function calls \ref barrier() for each node,
-    /// so it runs in O(n) time.
+    /// so it runs in \f$O(n)\f$ time.
     ///
     /// \pre Either \ref run() or \ref init() must be called before
Index: lemon/clp.cc
===================================================================
--- lemon/clp.cc	(revision 576)
+++ lemon/clp.cc	(revision 462)
@@ -25,5 +25,5 @@
     _prob = new ClpSimplex();
     _init_temporals();
-    messageLevel(MESSAGE_NOTHING);
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -33,5 +33,5 @@
     cols = other.cols;
     _init_temporals();
-    messageLevel(MESSAGE_NOTHING);
+    messageLevel(MESSAGE_NO_OUTPUT);
   }
 
@@ -57,10 +57,10 @@
   }
 
-  ClpLp* ClpLp::newSolver() const {
+  ClpLp* ClpLp::_newSolver() const {
     ClpLp* newlp = new ClpLp;
     return newlp;
   }
 
-  ClpLp* ClpLp::cloneSolver() const {
+  ClpLp* ClpLp::_cloneSolver() const {
     ClpLp* copylp = new ClpLp(*this);
     return copylp;
@@ -431,22 +431,6 @@
   }
 
-  void ClpLp::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _prob->setLogLevel(0);
-      break;
-    case MESSAGE_ERROR:
-      _prob->setLogLevel(1);
-      break;
-    case MESSAGE_WARNING:
-      _prob->setLogLevel(2);
-      break;
-    case MESSAGE_NORMAL:
-      _prob->setLogLevel(3);
-      break;
-    case MESSAGE_VERBOSE:
-      _prob->setLogLevel(4);
-      break;
-    }
+  void ClpLp::messageLevel(MessageLevel m) {
+    _prob->setLogLevel(static_cast<int>(m));
   }
 
Index: lemon/clp.h
===================================================================
--- lemon/clp.h	(revision 576)
+++ lemon/clp.h	(revision 462)
@@ -57,9 +57,4 @@
     ~ClpLp();
 
-    /// \e
-    virtual ClpLp* newSolver() const;
-    /// \e
-    virtual ClpLp* cloneSolver() const;
-
   protected:
 
@@ -71,4 +66,7 @@
 
   protected:
+
+    virtual ClpLp* _newSolver() const;
+    virtual ClpLp* _cloneSolver() const;
 
     virtual const char* _solverName() const;
@@ -137,6 +135,4 @@
     virtual void _clear();
 
-    virtual void _messageLevel(MessageLevel);
-    
   public:
 
@@ -156,4 +152,24 @@
     int clpCol(Col c) const { return cols(id(c)); }
 
+    ///Enum for \c messageLevel() parameter
+    enum MessageLevel {
+      /// no output (default value)
+      MESSAGE_NO_OUTPUT = 0,
+      /// print final solution
+      MESSAGE_FINAL_SOLUTION = 1,
+      /// print factorization
+      MESSAGE_FACTORIZATION = 2,
+      /// normal output
+      MESSAGE_NORMAL_OUTPUT = 3,
+      /// verbose output
+      MESSAGE_VERBOSE_OUTPUT = 4
+    };
+    ///Set the verbosity of the messages
+
+    ///Set the verbosity of the messages
+    ///
+    ///\param m is the level of the messages output by the solver routines.
+    void messageLevel(MessageLevel m);
+
   };
 
Index: lemon/concepts/digraph.h
===================================================================
--- lemon/concepts/digraph.h	(revision 580)
+++ lemon/concepts/digraph.h	(revision 529)
@@ -422,9 +422,10 @@
       Node oppositeNode(const Node&, const Arc&) const { return INVALID; }
 
-      /// \brief Reference map of the nodes to type \c T.
-      ///
-      /// Reference map of the nodes to type \c T.
+      /// \brief Read write map of the nodes to type \c T.
+      ///
+      /// ReadWrite map of the nodes to type \c T.
+      /// \sa Reference
       template<class T>
-      class NodeMap : public ReferenceMap<Node, T, T&, const T&> {
+      class NodeMap : public ReadWriteMap< Node, T > {
       public:
 
@@ -436,6 +437,5 @@
       private:
         ///Copy constructor
-        NodeMap(const NodeMap& nm) : 
-          ReferenceMap<Node, T, T&, const T&>(nm) { }
+        NodeMap(const NodeMap& nm) : ReadWriteMap< Node, T >(nm) { }
         ///Assignment operator
         template <typename CMap>
@@ -446,9 +446,10 @@
       };
 
-      /// \brief Reference map of the arcs to type \c T.
+      /// \brief Read write map of the arcs to type \c T.
       ///
       /// Reference map of the arcs to type \c T.
+      /// \sa Reference
       template<class T>
-      class ArcMap : public ReferenceMap<Arc, T, T&, const T&> {
+      class ArcMap : public ReadWriteMap<Arc,T> {
       public:
 
@@ -459,6 +460,5 @@
       private:
         ///Copy constructor
-        ArcMap(const ArcMap& em) :
-          ReferenceMap<Arc, T, T&, const T&>(em) { }
+        ArcMap(const ArcMap& em) : ReadWriteMap<Arc,T>(em) { }
         ///Assignment operator
         template <typename CMap>
@@ -472,5 +472,4 @@
       struct Constraints {
         void constraints() {
-          checkConcept<BaseDigraphComponent, _Digraph>();
           checkConcept<IterableDigraphComponent<>, _Digraph>();
           checkConcept<IDableDigraphComponent<>, _Digraph>();
Index: lemon/concepts/graph.h
===================================================================
--- lemon/concepts/graph.h	(revision 580)
+++ lemon/concepts/graph.h	(revision 529)
@@ -498,9 +498,10 @@
       };
 
-      /// \brief Reference map of the nodes to type \c T.
-      ///
-      /// Reference map of the nodes to type \c T.
+      /// \brief Read write map of the nodes to type \c T.
+      ///
+      /// ReadWrite map of the nodes to type \c T.
+      /// \sa Reference
       template<class T>
-      class NodeMap : public ReferenceMap<Node, T, T&, const T&>
+      class NodeMap : public ReadWriteMap< Node, T >
       {
       public:
@@ -513,6 +514,5 @@
       private:
         ///Copy constructor
-        NodeMap(const NodeMap& nm) :
-          ReferenceMap<Node, T, T&, const T&>(nm) { }
+        NodeMap(const NodeMap& nm) : ReadWriteMap< Node, T >(nm) { }
         ///Assignment operator
         template <typename CMap>
@@ -523,9 +523,10 @@
       };
 
-      /// \brief Reference map of the arcs to type \c T.
-      ///
-      /// Reference map of the arcs to type \c T.
+      /// \brief Read write map of the directed arcs to type \c T.
+      ///
+      /// Reference map of the directed arcs to type \c T.
+      /// \sa Reference
       template<class T>
-      class ArcMap : public ReferenceMap<Arc, T, T&, const T&>
+      class ArcMap : public ReadWriteMap<Arc,T>
       {
       public:
@@ -537,6 +538,5 @@
       private:
         ///Copy constructor
-        ArcMap(const ArcMap& em) :
-          ReferenceMap<Arc, T, T&, const T&>(em) { }
+        ArcMap(const ArcMap& em) : ReadWriteMap<Arc,T>(em) { }
         ///Assignment operator
         template <typename CMap>
@@ -547,9 +547,10 @@
       };
 
-      /// Reference map of the edges to type \c T.
-
-      /// Reference map of the edges to type \c T.
+      /// Read write map of the edges to type \c T.
+
+      /// Reference map of the arcs to type \c T.
+      /// \sa Reference
       template<class T>
-      class EdgeMap : public ReferenceMap<Edge, T, T&, const T&>
+      class EdgeMap : public ReadWriteMap<Edge,T>
       {
       public:
@@ -561,6 +562,5 @@
       private:
         ///Copy constructor
-        EdgeMap(const EdgeMap& em) :
-          ReferenceMap<Edge, T, T&, const T&>(em) {}
+        EdgeMap(const EdgeMap& em) : ReadWriteMap<Edge,T>(em) {}
         ///Assignment operator
         template <typename CMap>
@@ -602,33 +602,21 @@
       /// \brief Opposite node on an arc
       ///
-      /// \return The opposite of the given node on the given edge.
+      /// \return the opposite of the given Node on the given Edge
       Node oppositeNode(Node, Edge) const { return INVALID; }
 
       /// \brief First node of the edge.
       ///
-      /// \return The first node of the given edge.
+      /// \return the first node of the given Edge.
       ///
       /// Naturally edges don't have direction and thus
-      /// don't have source and target node. However we use \c u() and \c v()
-      /// methods to query the two nodes of the arc. The direction of the
-      /// arc which arises this way is called the inherent direction of the
+      /// don't have source and target node. But we use these two methods
+      /// to query the two nodes of the arc. The direction of the arc
+      /// which arises this way is called the inherent direction of the
       /// edge, and is used to define the "default" direction
       /// of the directed versions of the arcs.
-      /// \sa v()
-      /// \sa direction()
+      /// \sa direction
       Node u(Edge) const { return INVALID; }
 
       /// \brief Second node of the edge.
-      ///
-      /// \return The second node of the given edge.
-      ///
-      /// Naturally edges don't have direction and thus
-      /// don't have source and target node. However we use \c u() and \c v()
-      /// methods to query the two nodes of the arc. The direction of the
-      /// arc which arises this way is called the inherent direction of the
-      /// edge, and is used to define the "default" direction
-      /// of the directed versions of the arcs.
-      /// \sa u()
-      /// \sa direction()
       Node v(Edge) const { return INVALID; }
 
@@ -749,5 +737,4 @@
       struct Constraints {
         void constraints() {
-          checkConcept<BaseGraphComponent, _Graph>();
           checkConcept<IterableGraphComponent<>, _Graph>();
           checkConcept<IDableGraphComponent<>, _Graph>();
